Package uk.ac.starlink.table.join

# Class EqualsMatchEngine

java.lang.Object
uk.ac.starlink.table.join.EqualsMatchEngine

All Implemented Interfaces:
  `MatchEngine`

public class EqualsMatchEngine extends Object implements MatchEngine
Match engine which considers two rows matched if they contain objects which are non-blank and equal. The objects will typically be strings, but could equally be something else. Match scores are always either 0.0 (equal) or -1.0 (unequal).

The equality is roughly in the sense of `Object.equals(java.lang.Object)`, but some additional work is done, so that for instance (multi-dimensional) arrays are compared (recursively) on their contents, and blank objects are compared in the sense used in the rest of STIL. A blank value is not considered equal to anything, including another blank value. Scalar numeric values are, as far as possible, compared on numeric value rather than object equality, though this numeric value comparison does not currently apply to arrays.

Since:
  25 Mar 2004
Author:
  Mark Taylor (Starlink)

## Constructor Summary

Constructors
Constructor
Description
`EqualsMatchEngine()`

## Method Summary

Modifier and Type
Method
Description
`Supplier<Coverage>`
`createCoverageFactory()`
Returns null.
`Supplier<MatchKit>`
`createMatchKitFactory()`
Returns a factory for MatchKit instances corresponding to the current settings of this object.
`uk.ac.starlink.table.DescribedValue[]`
`getMatchParameters()`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria.
`uk.ac.starlink.table.ValueInfo`
`getMatchScoreInfo()`
The match score is uninteresting, since it's either -1 or 0.
`double`
`getScoreScale()`
Returns a scale value for the match score.
`uk.ac.starlink.table.DescribedValue[]`
`getTuningParameters()`
Returns a set of DescribedValue objects whose values can be modified to tune the performance of the match.
`uk.ac.starlink.table.ValueInfo[]`
`getTupleInfos()`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple.
`String`
`toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### EqualsMatchEngine

public EqualsMatchEngine()

## Method Details

### createMatchKitFactory

public Supplier<MatchKit> createMatchKitFactory()
Description copied from interface: `MatchEngine`
Returns a factory for MatchKit instances corresponding to the current settings of this object.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

Specified by:
  `createMatchKitFactory` in interface `MatchEngine`
Returns:
  match kit supplier

### createCoverageFactory

public Supplier<Coverage> createCoverageFactory()
Returns null. You could check bounds on hashcodes, but it's not likely to be very revealing.

Specified by:
  `createCoverageFactory` in interface `MatchEngine`
Returns:
  supplier of coverage objects, or null

### getScoreScale

public double getScoreScale()
Description copied from interface: `MatchEngine`
Returns a scale value for the match score. The intention is that the result of `matchScore`/`MatchEngine.getScoreScale()` is of order unity, and is thus comparable between different match engines.

As a general rule, the result should be the maximum value ever returned from the `matchScore` method, corresponding to the least good successful match. For binary MatchEngine implementations (all matches are either score=0 or failures) a value of 1 is recommended. If nothing reliable can be said about the scale, NaN may be returned.

Specified by:
  `getScoreScale` in interface `MatchEngine`
Returns:
  scale of successful match scores, a positive finite number or NaN

### getMatchScoreInfo

public uk.ac.starlink.table.ValueInfo getMatchScoreInfo()
The match score is uninteresting, since it's either -1 or 0. We flag this by returning `null` here.

Specified by:
  `getMatchScoreInfo` in interface `MatchEngine`
Returns:
  null

### getTupleInfos

public uk.ac.starlink.table.ValueInfo[] getTupleInfos()
Description copied from interface: `MatchEngine`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple. The length of this array is the number of elements in the tuple. Each element should at least have a defined name and content class. The info's `nullable` attribute has a special meaning: if true it means that it makes sense for this element of the tuple to be always blank (for instance assigned to no column).

Specified by:
  `getTupleInfos` in interface `MatchEngine`
Returns:
  array of objects describing the requirements on each element of the tuples used for matching

### getMatchParameters

public uk.ac.starlink.table.DescribedValue[] getMatchParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria. Typically at least one of these will be some sort of tolerance separation which determines how close tuples must be to count as a match. This match engine's behaviour can be modified by calling `DescribedValue.setValue(java.lang.Object)` on the returned objects.

Specified by:
  `getMatchParameters` in interface `MatchEngine`
Returns:
  array of described values which influence the match

### getTuningParameters

public uk.ac.starlink.table.DescribedValue[] getTuningParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to tune the performance of the match. This match engine's performance can be influenced by calling `DescribedValue.setValue(java.lang.Object)` on the returned objects.

Changing these values will make no difference to the output of `MatchKit.matchScore(java.lang.Object[], java.lang.Object[])`, but may change the output of `MatchKit.getBins(java.lang.Object[])`. This may change the CPU and memory requirements of the match, but will not change the result. The default value should be something sensible, so that setting the value of these parameters is not in general required.

Specified by:
  `getTuningParameters` in interface `MatchEngine`
Returns:
  array of described values which may influence match performance

### toString

public String toString()

Overrides:
  `toString` in class `Object`